Subject: Re: bug#45631: 27.1; regression: message-forward-ignored-headers no longer applies when forwarding as MIME

From: Robert Pluim <[email-masked]>
Date: Wed, 06 Jan 2021 11:31:25 +0100

Daniel Kahn Gillmor <[email-masked]> writes:

> Hi Robert--
>
> Thanks for taking a look into this!
>
> On Tue 2021-01-05 14:06:54 +0100, Robert Pluim wrote:
>> Iʼve compared emacs-26 and emacs-27, and the code is the same, which
>> leads me to suspect something different in your
>> configuration. 'message-forward-ignored-headers' is applied even when
>> forwarding as MIME (despite the docstring)
>
> hm, the docstring change was recent, apparently in response to #27715 :
>
> https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=57fbf0cf7bd4a85f2ad6f14aa92494545106b887
>
> that's why i assumed there had been a change.
>

Documentation lags implementation, as always :-)

>> except when 'message-forward-show-mml' is nil, or when itʼs 'best' and
>> the forwarded message is either signed or encrypted.
>
> Hm, i'm using 'best' for message-forward-show-mml (as the default) and
> yes, it looks like the issue is that i just noticed it happening when
> i went to forward a signed message.  Maybe it wasn't an issue before
> because i wasn't forwarding a signed message?  I no longer have emacs
> 26.3 installed so i can't check that handily right now.
>
> The message headers (outside of the cryptographic envelope) do *not*
> affect the digital signature, so they ought to be safe to trim out
> without invalidating the digital signature.  These are the message
> headers that i want to trim.
>
>> Or maybe youʼre forwarding from inside the *Article* buffer, I think
>> Gnus behaves differently then.
>
> I'm using notmuch-emacs, not gnus, but it reuses a lot of the existing
> emacs MUA codebase, which is why i'm reporting it here.
>
> Do you have a suggestion for how i can apply
> message-forward-ignored-headers to a signed message?  I only want it to
> apply to headers that aren't covered by the digital signature anyway.

I think setting message-forward-show-mml to t will do what you want,
then message won't bother to check if the message is signed/encrypted,
and will thus apply message-forward-ignored-headers.

Robert